unit cdanceu;

// Copyright  1999 by Ziff-Davis, Inc.
// Written by Neil J. Rubenking



interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, ToolWin, Menus, ActnList, StdCtrls,
  ImgList, StdActns, Buttons, IcoObjU, AppEvnts, palConsU, palfrmu;

CONST
  dimn = 32;
  dmax = dimn-1;
type
  TCellsType = ARRAY[0..dmax,0..dmax] OF SmallInt;
  TMainForm = class(TForm)
    alMain           : TActionList;
      // File category
        amNew256     : TAction;
        amNew16      : TAction;
        amOpen       : TAction;
        amSave       : TAction;
        amSaveAs     : TAction;
        amSaveAsCur  : TAction;
        amLoadCur    : TAction;
        amExit       : TAction;
      // Edit category
        amCut        : TEditCut;
        amCopy       : TEditCopy;
        amPaste      : TEditPaste;
        amClear      : TAction;
        amSelAll     : TAction;
        amSelNone    : TAction;
        amHeader     : TAction;
    alTools          : TActionList;
    atPencil: TAction;
      atChoos        : TAction;
      atDropp        : TAction;
      atPaint        : TAction;
      atLinee        : TAction;
      atRectO        : TAction;
      atRectF        : TAction;
      atLipsO        : TAction;
      atLipsF        : TAction;
      atHotsp        : TAction;
    alActions        : TActionList;
      aShiftLeft     : TAction;
      aShiftRite     : TAction;
      aShiftUppp     : TAction;
      aShiftDown     : TAction;
      aRotateLeft    : TAction;
      aRotateRite    : TAction;
      aMirror        : TAction;
      aFlippp        : TAction;
      aChangeColors  : TAction;
    alFrames         : TActionList;
      afAdd          : TAction;
      afRefresh      : TAction;
      afRevert       : TAction;
      afRemove       : TAction;
      afUp           : TAction;
      afDown         : TAction;
      afJifs         : TAction;
      afClone        : TAction;
      afPrevu        : TAction;
    ilTools          : TImageList;
    ilToolsN         : TImageList;
    ilActs           : TImageList;
    ilActsN          : TImageList;
    MainMenu1        : TMainMenu;
      topFile        : TMenuItem;
        mnufNew256   : TMenuItem;
        mnufNew16    : TMenuItem;
        mnufOpen     : TMenuItem;
        mnufSave     : TMenuItem;
        mnufSaveAs   : TMenuItem;
        mnufLoadCur  : TMenuItem;
        mnufSaveCur  : TMenuItem;
        mnufExit     : TMenuItem;
      topEdit        : TMenuItem;
        mnueCut      : TMenuItem;
        mnueCopy     : TMenuItem;
        mnuePaste    : TMenuItem;
        mnueDel      : TMenuItem;
        mnueSelAll   : TMenuItem;
        mnueSelNone  : TMenuItem;
        mnueHeader   : TMenuItem;
      topTools       : TMenuItem; // order must match tbTools
        tm1          : TMenuItem;
        tm2          : TMenuItem;
        tm3          : TMenuItem;
        tm4          : TMenuItem;
        tm5          : TMenuItem;
        tm6          : TMenuItem;
        tm7          : TMenuItem;
        tm8          : TMenuItem;
        tm9          : TMenuItem;
        tm10         : TMenuItem;
      topActions     : TMenuItem;
        mnuaShiftL   : TMenuItem;
        mnuaShiftR   : TMenuItem;
        mnuaShiftU   : TMenuItem;
        mnuaShiftD   : TMenuItem;
        mnuaRotL     : TMenuItem;
        mnuaRotR     : TMenuItem;
        mnuaMirror   : TMenuItem;
        mnuaFlip     : TMenuItem;
        mnuaChange   : TMenuItem;
      topFrames      : TMenuItem;
        mnurAdd      : TMenuItem;
        mnurRemove   : TMenuItem;
        mnurRevert   : TMenuItem;
        mnurRefresh  : TMenuItem;
        mnurUp       : TMenuItem;
        mnurDown     : TMenuItem;
        mnurJiffies  : TMenuItem;
        mnurClone    : TMenuItem;
        mnurPreview  : TMenuItem;
      topHelp        : TMenuItem;
        mnuhTopics   : TMenuItem;
        mnuhAbout    : TMenuItem;
    tbTools          : TToolBar; // order must match topTools
      tb1            : TToolButton;
      tb2            : TToolButton;
      tb3            : TToolButton;
      tb4            : TToolButton;
      tb5            : TToolButton;
      tb6            : TToolButton;
      tb7            : TToolButton;
      tb8            : TToolButton;
      tb9            : TToolButton;
      tb10           : TToolButton;
    tbActions        : TToolBar;
      tbShiftR       : TToolButton;
      tbShiftL       : TToolButton;
      tbShiftU       : TToolButton;
      tbShiftD       : TToolButton;
      tbRotL         : TToolButton;
      tbRotR         : TToolButton;
      tbMirror       : TToolButton;
      tbFlip         : TToolButton;
      tbChange       : TToolButton;
    pnlDraw          : TPanel;
      pbDraw         : TPaintBox;
    pnlFrames        : TPanel;
      sbAdd          : TSpeedButton;
      sbInsert       : TSpeedButton;
      sbRefresh      : TSpeedButton;
      sbClone        : TSpeedButton;
      sbRemove       : TSpeedButton;
      sbJiffies      : TSpeedButton;
      sbUp           : TSpeedButton;
      sbDown         : TSpeedButton;
    lbFrames         : TListBox;
    pnlPrevu         : TPanel;
      lbPrevu1       : TLabel;
      lbPrevu2       : TLabel;
    TPal             : TPalFrame;
    StatusBar1       : TStatusBar;
      imgAsterisk    : TImage;
    OpenDialog1      : TOpenDialog;
    SaveDialog1      : TSaveDialog;
    OpenDialog2      : TOpenDialog;
    SaveDialog2      : TSaveDialog;
    AppEvents1       : TApplicationEvents;
    // Boring menu and toolbar separators...
    N1               : TMenuItem;
    N2               : TMenuItem;
    N3               : TMenuItem;
    N4               : TMenuItem;
    N5               : TMenuItem;
    N6               : TMenuItem;
    N7               : TMenuItem;
    N8               : TMenuItem;
    N9               : TMenuItem;
    N10              : TMenuItem;
    N11              : TMenuItem;
    tbSep1           : TToolButton;
    tbSep2           : TToolButton;
    Label1: TLabel;
    FixNTTimer: TTimer;
    procedure FormCreate               (Sender: TObject);
    procedure FormDestroy              (Sender: TObject);
    procedure FormResize               (Sender: TObject);
    procedure FormActivate             (Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure amNewExecute             (Sender: TObject);
    procedure amOpenExecute            (Sender: TObject);
    procedure amSaveUpdate             (Sender: TObject);
    procedure amSaveExecute            (Sender: TObject);
    procedure amSaveAsExecute          (Sender: TObject);
    procedure amSaveAsCurExecute       (Sender: TObject);
    procedure amLoadCurExecute         (Sender: TObject);
    procedure amExitExecute            (Sender: TObject);
    procedure amCutUpdate              (Sender: TObject);
    procedure amCutExecute             (Sender: TObject);
    procedure amCopyExecute            (Sender: TObject);
    procedure amClearExecute           (Sender: TObject);
    procedure amPasteExecute           (Sender: TObject);
    procedure amSelAllExecute          (Sender: TObject);
    procedure amSelNoneExecute         (Sender: TObject);
    procedure amHeaderExecute          (Sender: TObject);
    procedure atAllToolExecute         (Sender: TObject);
    procedure aShiftLeftExecute        (Sender: TObject);
    procedure aShiftRiteExecute        (Sender: TObject);
    procedure aShiftUpppExecute        (Sender: TObject);
    procedure aShiftDownExecute        (Sender: TObject);
    procedure aRotateLeftExecute       (Sender: TObject);
    procedure aRotateRiteExecute       (Sender: TObject);
    procedure aMirrorExecute           (Sender: TObject);
    procedure aFlipppExecute           (Sender: TObject);
    procedure aChangeColorsExecute     (Sender: TObject);
    procedure afAddUpdate              (Sender: TObject);
    procedure afAddExecute             (Sender: TObject);
    procedure afRefreshExecute         (Sender: TObject);
    procedure afRevertExecute          (Sender: TObject);
    procedure afRemoveExecute          (Sender: TObject);
    procedure afCloneExecute           (Sender: TObject);
    procedure afUpExecute              (Sender: TObject);
    procedure afDownExecute            (Sender: TObject);
    procedure afJifsExecute            (Sender: TObject);
    procedure afPrevuExecute           (Sender: TObject);
    procedure mnuhTopicsClick          (Sender: TObject);
    procedure mnuhAboutClick           (Sender: TObject);
    procedure pnlDrawMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure pbDrawPaint(Sender: TObject);
    procedure pbDrawMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pbDrawMouseMove(Sender: TObject; Shift: TShiftState;
      X,Y: Integer);
    procedure pbDrawMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lbFramesDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure pnlFramesMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure StatusBar1MouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure lbFramesClick(Sender: TObject);
    procedure AppEvents1Hint(Sender: TObject);
    procedure StatusBar1DblClick(Sender: TObject);
    procedure FixNTTimerTimer(Sender: TObject);
  private
    { Private declarations }
    IsDirty           : Boolean; // true if current file modified
    theFilename       : String;  // filename being worked on
    theFilenameC      : String;  // .cur filename being worked on
    theFolder         : String;  // last-accessed folder
    theFolderC        : String;  // last-accessed folder for .cur

    OneCell           : Integer; // one cell in drawing area
    Adj               : Integer; // adjust stretch-rectangle
    HalfCell          : Integer; // 1/2 cell in drawing area
    AllCell           : Integer; // full size of drawing area
    Margin            : Integer; // margin in drawing area
    Cells             : TCellsType;
                                 // ^ color values in drawing area
    MyClipboardFmt    : DWORD;   // program-specific clipboard format
    DragIdx           : Integer; // primary color during drag
    DragNIdx          : Integer; // secondary color during drag
    DragX, DragY      : Integer; // starting location for drag
    WasX, WasY        : Integer; // previous location for drag
    GotDown           : Integer; // prevents stray MouseUp events

    IsPal16           : Boolean;   // true if palette is 16-color
    ToolIdx           : Integer; // index of drawing tool
    DragStatus        : Integer; // status when dragging selection
                        // 0=none, 1=not moved yet, 2= moved
    FoRect            : TRect; // being-dragged area
    MCells            : TCellsType;
                        // ^ colors of being-dragged area
    aniAuthor         : String;  // author name
    aniTitle          : String;  // descriptive title
    allJifs           : Integer; // general JIF-length
    HotX              : Word;    // hotspot X-value
    HotY              : Word;    // hotspot Y-value
    ImageIdx          : Integer; // previous index in lbFrames
    sbParts           : ARRAY[0..3] OF Integer;
                        // ^ status panel divisions
    function  CellFmPixel(X, Y : Integer;
      VAR cX, cY : Integer): Boolean;
    function  CenterOf(I : Integer) : Integer;
    function  CheckSave : Boolean;
    procedure ClearDrag;
    procedure ColorChange(Sender: TObject);
    function  CurrentToCursObj(Old : TInternalCur) : TInternalCur;
    procedure DoFocusRect(Show : Boolean);
    procedure DrawEllipse(xCtr, yCtr, xAxis, yAxis : integer;
      colorIdx, fillIdx : Integer);
    procedure DrawLine(x1, y1, x2, y2 : integer; colorIdx : Integer);
    procedure DropDrag;
    function  GetACell(co, ro : Integer) : Integer;
    procedure CursObjToCurrent(T : TInternalCur);
    procedure JustPaint(co, ro, colr : Integer);
    function  MoreThan256 : Boolean;
    function  NameForFile(const S : String) : String;
    procedure OpenTheFile(const S : String);
    procedure OpenTheFrame(const S : String);
    procedure PaintFoRectCells;
    procedure PaintOne(co, ro, colr : Integer);
    procedure PrepareSelection;
    function  PtInFoRect(X, Y : Integer) : Boolean;
    function  RectAlign(fL, fT, fR, fB : Integer) : TRect;
    function  RotateRect(R : TRect) : TRect;
    procedure SaveTheFile(const S : String);
    procedure SaveTheFrame(const S : String);
    function  SetCell(co, ro, colr : Integer) : Boolean;
    procedure SetDirty(Value : Boolean);
    procedure SetFilename(const S : String);
    procedure SetToolIndex(newIndex : Integer);
    procedure ShowHotSpot(Sho : Boolean);
    procedure SnapLine(X1, Y1 : Integer; VAR X2, Y2 : Integer);
    procedure SnapRect(X1, Y1 : Integer; VAR X2, Y2 : Integer);
    procedure UnderFoRectCells;
    function  ValidCell(vCo, vRo : Integer) : Boolean;
    procedure WorkingImage;
    procedure WMDropFiles(VAR Msg : TWMDropFiles);
      message WM_DROPFILES;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses clipbrd, shellapi, IniFiles, AboutBox, allfuncs, readAniU,
  jifformu, hdrformu;

type
  PClippedRect = ^TClippedRect;
  TClippedRect = packed record
    Is16Color     : Boolean;
    width, height : byte;
    cells         : ARRAY[0..1023] OF SmallInt;
  end;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
VAR N, I, cur, co, ro : Integer;
  TB : TBitmap;
begin
  IF ShellVersionIs4_70 THEN
    begin
      tbTools.AutoSize   := True;
      tbActions.AutoSize := True;
    end
  ELSE
    begin
      tbTools.Flat     := False;
      tbActions.Flat   := False;
      tbTools.Images   := ilTools;
      tbActions.Images := ilActs;
    end;
  // It's necessary to load the image lists at run time
  // in order to support shell versions before 4.7, and to
  // avoid problems with changing color depth
  TB := TBitmap.Create;
  try
    FOR N := 40 TO 51 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 16, 16, lr_DefaultColor);
        ilTools.Addmasked(TB, clFuchsia);
      end;
    FOR N := 52 TO 60 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 16, 16, lr_DefaultColor);
        ilActs.Addmasked(TB, clFuchsia);
      end;
    FOR N := 70 TO 81 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 16, 16, lr_DefaultColor);
        ilToolsN.Addmasked(TB, clFuchsia);
      end;
    FOR N := 82 TO 90 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 16, 16, lr_DefaultColor);
        ilActsN.Addmasked(TB, clFuchsia);
      end;
  finally
    TB.Free;
  end;

  TPal.OnColorChange := ColorChange;
  // Initialize sbParts array, used to give status bar panels
  // their own flyover help
  I := 0;
  FOR N := 0 TO 3 DO
    begin
      Inc(I, StatusBar1.Panels[N].Width);
      sbParts[N] := I;
    end;
  Application.HelpFile := ChangeFileExt(Application.ExeName, '.HLP');
  WITH TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI')) DO
  try
    theFolder := FinalSlash(ReadString('Location', 'Location',
      ExtractFileDir(Application.ExeName)));
    theFolderC := FinalSlash(ReadString('Location', 'LocationC',
      ExtractFileDir(Application.ExeName)));
  finally
    Free;
  end;
  OpenDialog1.InitialDir := theFolder;
  OpenDialog2.InitialDir := theFolderC;
  SetFilename('');
  DragAcceptFiles(Self.Handle, True);

  IsPal16 := True;
  TPal.SetPalValues(True);
  GetPosFmExeName(Application.ExeName, Self, True);
  MyClipboardFmt := RegisterClipboardFormat('PC Mag CursorDance');
  FOR N := 1 TO 11 DO
    begin
      cur := AniCurFromResource(MakeIntResource(N+20));
      IF cur = 0 THEN // If it fails for some reason, use static
        cur := LoadCursor(HInstance, MakeIntResource(N));
      Screen.Cursors[N] := cur;
    end;
  GotDown       := 0;
  aniAuthor     := '';
  aniTitle      := '';
  allJifs       := 10;
  pbDraw.Cursor := 1;
  dragIdx       := -1;
  dragNIdx      := -1;
  DragX         := -1;
  DragY         := -1;
  WasX          := MaxInt;
  WasY          := MaxInt;
  HotX          := 0;
  HotY          := 0;
  ToolIdx       := 0;
  ClearDrag;
  ImageIdx      := -1;
  SetDirty(False);
  FOR co := 0 TO dmax DO
    FOR ro := 0 TO dmax DO
      Cells[co,ro] := palTrans;
  pbDraw.Refresh;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  DragAcceptFiles(Self.Handle, False);
  WITH TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI')) DO
  try
    WriteString('Location', 'Location', theFolder);
    WriteString('Location', 'LocationC', theFolderC);
  finally
    Free;
  end;
  SetPosToExeName(Application.ExeName, Self, True);
end;

procedure TMainForm.FormResize(Sender: TObject);
// When form resizes, make sure lbFrames is at least
// 120 pixels wide
VAR W, Mrg : Integer;
begin
  WITH pnlDraw DO Width := Height;
  IF GetWindowLong(Self.Handle, GWL_STYLE) AND WS_MAXIMIZE = 0 THEN
    begin
      W := tbTools.Width + pnlDraw.Width + pnlFrames.Width + 120 +
        GetSystemMetrics(SM_CXHSCROLL) + (Width - ClientWidth);
      IF W > 600 THEN
        Constraints.minWidth := W
      ELSE Constraints.MinWidth := 600;
    end;
  IF WindowState = wsMaximized THEN
    begin // Coming down from maximized; tweak width to get list sized right
      WindowState := wsNormal;
      Width := Width + 1;
      Width := Width - 1;
    end;
  W := pnlDraw.Width-4;
  OneCell := W DIV dimn;
  IF (OneCell * dimn) + 8 > W THEN
    Dec(OneCell);
  IF Odd(OneCell) THEN
    Adj         := 2
  ELSE Adj      := 1;
  HalfCell      := OneCell DIV 2;
  AllCell       := (OneCell*dimn)+1;
  Mrg           := (W - AllCell) DIV 2;
  Margin        := 0;
  pbDraw.Left   := Mrg+2;
  pbDraw.Top    := Mrg+2;
  pbDraw.Width  := AllCell;
  pbDraw.Height := AllCell;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  IF (ParamCount > 0) AND FileExists(ParamStr(1)) THEN
    OpenTheFile(ParamStr(1));
  //FIX: For reasons unknown, under NT4, the Status Bar's color
  // panels do not refresh properly at startup. Doing it in this
  // timer makes them work fine.
  FixNTTimer.Enabled := True;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := CheckSave;
end;

procedure TMainForm.amNewExecute(Sender: TObject);
VAR N, co, ro : Integer;
begin
  IF NOT CheckSave THEN Exit;
  FOR N := 0 TO lbFrames.Items.Count-1 DO
    TInternalCur(lbFrames.items.Objects[N]).Free;
  lbFrames.Clear;
  IsPal16 := (Sender AS TAction).Tag = 16;
  TPal.SetPalValues(IsPal16);
  aniAuthor     := '';
  aniTitle      := '';
  allJifs       := 10;
  SetToolIndex(0);
  dragIdx       := -1;
  dragNIdx      := -1;
  DragX         := -1;
  DragY         := -1;
  WasX          := MaxInt;
  WasY          := MaxInt;
  HotX          := 0;
  HotY          := 0;
  ToolIdx       := 0;
  ClearDrag;
  ImageIdx      := -1;
  SetDirty(False);
  FOR co := 0 TO dmax DO
    FOR ro := 0 TO dmax DO
      Cells[co,ro] := palTrans;
  pbDraw.Refresh;
  TPal.Refresh;
  StatusBar1.Refresh;
  SetFilename('');
  Screen.Cursors[12] := 0;
end;

procedure TMainForm.amOpenExecute(Sender: TObject);
begin
  IF NOT CheckSave THEN Exit;
  OpenDialog1.Filename := theFilename;
  IF NOT OpenDialog1.Execute THEN Exit;
  OpenDialog1.InitialDir := '';
  OpenTheFile(OpenDialog1.Filename);
end;

procedure TMainForm.amSaveUpdate(Sender: TObject);
begin
  amSave.Enabled      := (lbFrames.Items.Count > 0) AND IsDirty;
  amSaveAs.Enabled    := lbFrames.Items.Count > 0;
  amSaveAsCur.Enabled := lbFrames.ItemIndex >= 0;
  amNew256.Enabled    := MoreThan256;
end;

procedure TMainForm.amSaveExecute(Sender: TObject);
begin
  IF theFilename = '' THEN amSaveAsExecute(amSaveAs)
  ELSE SaveTheFile(theFilename);
end;

procedure TMainForm.amSaveAsExecute(Sender: TObject);
begin
  SaveDialog1.Filename := theFilename;
  IF NOT SaveDialog1.Execute THEN Exit;
  SaveTheFile(SaveDialog1.Filename);
end;

procedure TMainForm.amSaveAsCurExecute(Sender: TObject);
VAR S : String;
begin
  S := theFilename;
  SetLength(S, Length(S)-Length(ExtractFileExt(S)));
  SaveDialog2.Filename := Format('%s(%d).CUR',
    [S, lbFrames.ItemIndex]);
  IF NOT SaveDialog2.Execute THEN Exit;
  SaveTheFrame(SaveDialog2.Filename);
end;

procedure TMainForm.amLoadCurExecute(Sender: TObject);
begin
  OpenDialog2.Filename := TheFilenameC;
  IF NOT OpenDialog2.Execute THEN Exit;
  OpenDialog2.InitialDir := '';
  OpenTheFrame(OpenDialog2.Filename);
  TheFilenameC := OpenDialog2.Filename;
end;

procedure TMainForm.amExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.amCutUpdate(Sender: TObject);
begin
  amCut.Enabled     := DragStatus > 0;
  amCopy.Enabled    := DragStatus > 0;
  amClear.Enabled   := DragStatus > 0;
  amSelNone.Enabled := DragStatus > 0;
  amPaste.Enabled   := Clipboard.HasFormat(MyClipboardFmt) OR
    Clipboard.hasFormat(CF_BITMAP);
end;

procedure TMainForm.amCutExecute(Sender: TObject);
begin
  amCopyExecute(amCopy);
  amClearExecute(amClear);
end;

procedure TMainForm.amClearExecute(Sender: TObject);
VAR co, ro : Integer;
begin
  IF DragStatus = 1 THEN
    FOR ro := FoRect.Top TO FoRect.Bottom DO
      FOR co := FoRect.Left TO FoRect.Right DO
        PaintOne(co, ro, TPal.back);
  ClearDrag;
  DoFocusRect(False);
  pbDraw.Refresh;
  SetDirty(True);
end;

procedure TMainForm.amCopyExecute(Sender: TObject);
VAR
  H          : THandle;
  PCR        : PClippedRect;
  co, ro, N  : Integer;
  TempBitmap : TBitmap;
begin
  TempBitmap := TBitmap.Create;
  try
    H := GlobalAlloc(GMEM_MOVEABLE AND GMEM_DDESHARE,
      SizeOf(TClippedRect));
    IF H = 0 THEN Exit;
    PCR := GlobalLock(H);
    FillChar(PCR^, SizeOf(PCR^), 0);
    PCR^.Width        := FoRect.Right-FoRect.Left+1;
    PCR^.Height       := FoRect.Bottom-FoRect.Top+1;
    PCR^.Is16Color    := IsPal16;
    TempBitmap.Width  := PCR^.Width;
    TempBitmap.Height := PCR^.Height;
    N                 := 0;
    {$IFOPT R+}
    {$R-}
    {$DEFINE WasPlus}
    {$ENDIF}
    FOR ro := FoRect.Top TO FoRect.Bottom DO
      FOR co := FoRect.Left TO FoRect.Right DO
        begin
          IF DragStatus > 1 THEN
            PCR^.cells[N] := MCells[co-FoRect.Left,ro-FoRect.Top]
          ELSE
            PCR^.cells[N] := Cells[co,ro];
          TempBitmap.Canvas.Pixels[co-FoRect.Left,ro-FoRect.Top] :=
            TPal.Pal[PCR^.cells[N]];
          Inc(N);
        end;
    {$IFDEF WasPlus}
    {$R+}
    {$ENDIF}
    GlobalUnlock(H);
    Clipboard.Open;
    Clipboard.Assign(TempBitmap);
    Clipboard.SetAsHandle(MyClipboardFmt, H);
    Clipboard.Close;
  finally
    TempBitmap.Free;
  end;
end;

procedure TMainForm.amPasteExecute(Sender: TObject);
VAR
  H                       : THandle;
  PCR                     : PClippedRect;
  TCR                     : TClippedRect;
  co, ro, N, comax, romax : Integer;
  TempBitmap              : TBitmap;

  function AdjColor(idx : Integer; Was16, Is16 : Boolean) : Integer;
  begin
    IF (Was16 = Is16) OR (Idx > palMaxim) THEN Result := Idx
    ELSE IF Was16 THEN
      CASE Idx OF
        8..15 : Result := Idx+240;
        ELSE    Result := Idx;
      END
    ELSE
      CASE Idx OF
        0..7 : Result := Idx;
        248..255 : Result := Idx-240;
        ELSE Result := GetNearestPaletteIndex(TPal.palO,
          DefPal256[idx]);
      END;
  end;

  function MyNearestIndex(T : TColorRef) : Integer;
  // In the standard palette, half the solid colors are at the
  // very end. We match them first, because otherwise the
  // GetNearestPaletteIndex will find wrong matches earlier
  // in the palette
  VAR N : Integer;
  begin
    IF IsPal16 THEN
      Result := GetNearestPaletteIndex(TPal.palO, T)
    ELSE
      begin
        Result := -1;
        FOR N := 248 TO 255 DO
          IF T = DefPal256[N] THEN
            begin
              Result := N;
              Break;
            end;
        IF Result = -1 THEN
          Result := GetNearestPaletteIndex(TPal.palO, T);
      end;
  end;

begin
  IF DragStatus > 0 THEN
    DoFocusRect(True);
  IF DragStatus > 1 THEN
    FOR ro := FoRect.Top TO FoRect.Bottom DO
      FOR co := FoRect.Left TO FoRect.Right DO
        PaintOne(co, ro, MCells[co-FoRect.Left,ro-FoRect.Top]);
  IF Clipboard.HasFormat(MyClipboardFmt) THEN
    begin
      H := Clipboard.GetAsHandle(MyClipboardFmt);
      PCR := GlobalLock(H);
      Move(PCR^, TCR, SizeOf(TCR));
      GlobalUnlock(H);
      FoRect := Rect(0, 0, TCR.Width-1, TCR.Height-1);
      N := 0;
      FOR ro := FoRect.Top TO FoRect.Bottom DO
        FOR co := FoRect.Left TO FoRect.Right DO
          begin
            MCells[co-FoRect.Left,ro-FoRect.Top] := AdjColor(
              TCR.cells[N], TCR.Is16color, IsPal16);
            Inc(N);
          end;
    end
  ELSE IF Clipboard.HasFormat(CF_BITMAP) THEN
    begin
      TempBitmap := TBitmap.Create;
      try
        TempBitmap.Assign(Clipboard);
        comax := TempBitmap.Width-1;
        romax := TempBitmap.Height-1;
        IF comax > dimn-1 THEN comax := dimn-1;
        IF romax > dimn-1 THEN romax := dimn-1;
        FoRect := Rect(0, 0, comax, romax);
        WITH TempBitmap.Canvas DO
          FOR ro := 0 TO romax DO
            FOR co := 0 TO comax DO
              MCells[co,ro] := MyNearestIndex(Pixels[co,ro]);
      finally
        TempBitmap.Free;
      end;
    end
  ELSE Exit;
  DragStatus := 2;
  SetToolIndex(1);
  pbDraw.Refresh;
  SetDirty(True);
end;

procedure TMainForm.amSelAllExecute(Sender: TObject);
begin
  DropDrag;
  SetToolIndex(1);
  FoRect := Rect(0, 0, dmax, dmax);
  Move(Cells, MCells, SizeOf(MCells));
  DragStatus := 1;
  DoFocusRect(True);
end;

procedure TMainForm.amSelNoneExecute(Sender: TObject);
VAR Pt : TPoint;
begin
  DropDrag;
  IF pbDraw.Cursor = 11 THEN
    begin
      pbDraw.Cursor := 2;
      GetCursorPos(Pt);
      SetCursorPos(Pt.X, Pt.Y);
    end;
end;

procedure TMainForm.amHeaderExecute(Sender: TObject);
begin
  WITH THeaderForm.Create(Self) DO
  try
    SetData(aniTitle, aniAuthor);
    IF ShowModal = idOK THEN
      begin
        IF GetData(aniTitle, aniAuthor) THEN
          SetDirty(True);
      end;
  finally
    Free;
  end;
end;

procedure TMainForm.atAllToolExecute(Sender: TObject);
begin
  WITH Sender AS TAction DO
    begin
      SetToolIndex(Index);
      ShowHotSpot(Index=9);
    end;
end;

procedure TMainForm.aShiftLeftExecute(Sender: TObject);
VAR co, ro : Integer;
begin
  IF DragStatus = 0 THEN
    begin // shift the whole image
      FOR ro := 0 TO dimn-1 DO
        begin
          FOR co := 1 TO dimn-1 DO
            Cells[co-1, ro] := Cells[co, ro];
          Cells[dimn-1, ro] := TPal.back;
        end;
      pbDraw.Refresh;
    end
  ELSE
    begin // just shift the selection
      IF FoRect.Right <= 0 THEN Exit; 
      PrepareSelection;
      DoFocusRect(False);
      OffsetRect(FoRect, -1, 0);
      PaintFoRectCells;
      WITH FoRect DO
        FOR ro := Top TO bottom DO
          PaintOne(Right+1, ro, -1);
      DoFocusRect(True);
    end;
  SetDirty(True);
end;

procedure TMainForm.aShiftRiteExecute(Sender: TObject);
VAR co, ro : Integer;
begin
  IF DragStatus = 0 THEN
    begin // shift the whole image
      FOR ro := 0 TO dimn-1 DO
        begin
          FOR co := dimn-2 DOWNTO 0 DO
            Cells[co+1, ro] := Cells[co, ro];
          Cells[0, ro] := TPal.back;
        end;
      pbDraw.Refresh;
    end
  ELSE
    begin // shift the selection
      IF FoRect.Left >= 31 THEN Exit; 
      PrepareSelection;
      DoFocusRect(False);
      OffsetRect(FoRect, 1, 0);
      PaintFoRectCells;
      WITH FoRect DO
        FOR ro := Top TO bottom DO
          PaintOne(Left-1, ro, -1);
      DoFocusRect(True);
    end;
  SetDirty(True);
end;

procedure TMainForm.aShiftUpppExecute(Sender: TObject);
VAR co, ro : Integer;
begin
  IF DragStatus = 0 THEN
    begin // shift the whole image
      FOR co := 0 TO dimn-1 DO
        begin
          FOR ro := 1 TO dimn-1 DO
            Cells[co, ro-1] := Cells[co, ro];
          Cells[co, dimn-1] := TPal.back;
        end;
      pbDraw.Refresh;
    end
  ELSE
    begin // shift the selection
      IF FoRect.Bottom <= 0 THEN Exit;
      PrepareSelection;
      DoFocusRect(False);
      OffsetRect(FoRect, 0, -1);
      PaintFoRectCells;
      WITH FoRect DO
        FOR co := Left TO Right DO
          PaintOne(co, Bottom+1, -1);
      DoFocusRect(True);
    end;
  SetDirty(True);
end;

procedure TMainForm.aShiftDownExecute(Sender: TObject);
VAR co, ro : Integer;
begin
  IF DragStatus = 0 THEN
    begin // shift the whole image
      FOR co := 0 TO dimn-1 DO
        begin
          FOR ro := dimn-2 DOWNTO 0 DO
            Cells[co, ro+1] := Cells[co, ro];
          Cells[co, 0] := TPal.back;
        end;
      pbDraw.Refresh;
    end
  ELSE
    begin // shift the selection
      IF FoRect.Top >= 31 THEN Exit;
      PrepareSelection;
      DoFocusRect(False);
      OffsetRect(FoRect, 0, 1);
      PaintFoRectCells;
      WITH FoRect DO
        FOR co := Left TO Right DO
          PaintOne(co, Top-1, -1);
      DoFocusRect(True);
    end;
  SetDirty(True);
end;

procedure TMainForm.aRotateLeftExecute(Sender: TObject);
VAR
  co, ro  : Integer;
  NuRect  : TRect;
  NuCells : TCellsType;
begin
  IF DragStatus = 0 THEN
    begin // rotate the image
      FOR ro := 0 TO dimn-1 DO
        FOR co := 0 TO dimn-1 DO
          NuCells[ro, dimn-1-co] := Cells[co, ro];
      Cells := NuCells;
      pbDraw.Refresh;
    end
  ELSE
    begin // rotate the selection
      PrepareSelection;
      NuRect := RotateRect(FoRect);
      WITH FoRect DO
        FOR ro := 0 TO Bottom-Top DO
          FOR co := 0 TO Right-Left DO
            NuCells[ro, Right-Left-co] := MCells[co,ro];
      MCells := NuCells;
      UnderFoRectCells;
      DoFocusRect(False);
      FoRect := NuRect;
      DoFocusRect(True);
      PaintFoRectCells;
    end;
  SetDirty(True);
end;

procedure TMainForm.aRotateRiteExecute(Sender: TObject);
VAR
  co, ro  : Integer;
  NuRect  : TRect;
  NuCells : TCellsType;
begin
  IF DragStatus = 0 THEN
    begin // rotate the image
      FOR co := 0 TO dimn-1 DO
        FOR ro := 0 TO dimn-1 DO
          NuCells[dimn-1-ro, co] := Cells[co,ro];
      Cells := NuCells;
      pbDraw.Refresh;
    end
  ELSE
    begin // rotate the selection
      PrepareSelection;
      NuRect := RotateRect(FoRect);
      WITH FoRect DO
        FOR ro := 0 TO Bottom-Top DO
          FOR co := 0 TO Right-Left DO
            NuCells[Bottom-Top-ro, co] := MCells[co,ro];
      MCells := NuCells;
      UnderFoRectCells;
      DoFocusRect(False);
      FoRect := NuRect;
      DoFocusRect(True);
      PaintFoRectCells;
    end;
  SetDirty(True);
end;

procedure TMainForm.aMirrorExecute(Sender: TObject);
VAR co, ro, T : Integer;
begin
  IF DragStatus = 0 THEN
    begin // mirror the image
      FOR ro := 0 TO dimn-1 DO
        FOR co := 0 TO (dimn DIV 2)-1 DO
          begin
            T                    := cells[co, ro];
            cells[co,ro]         := cells[dimn-1-co, ro];
            cells[dimn-1-co, ro] := T;
          end;
      pbDraw.Refresh;
    end
  ELSE
    begin // mirror the selection
      PrepareSelection;
      WITH FoRect DO
        FOR ro := Top TO Bottom DO
          FOR co := Left TO (Left+Right) DIV 2 DO
            begin
              T                        := Mcells[co-left, ro-Top];
              Mcells[co-Left,ro-Top]   := Mcells[Right-co, ro-Top];
              Mcells[Right-co, ro-Top] := T;
            end;
      PaintFoRectCells;
    end;
  SetDirty(True);
end;

procedure TMainForm.aFlipppExecute(Sender: TObject);
VAR co, ro, T : Integer;
begin
  IF DragStatus = 0 THEN
    begin // flip the image
      FOR co := 0 TO dimn-1 DO
        FOR ro := 0 TO (dimn DIV 2)-1 DO
          begin
            T                    := cells[co, ro];
            cells[co,ro]         := cells[co, dimn-1-ro];
            cells[co, dimn-1-ro] := T;
          end;
      pbDraw.Refresh;
    end
  ELSE
    begin // flip the selection
      WITH FoRect DO
        FOR co := Left TO Right DO
          FOR ro := Top TO (Top+Bottom) DIV 2 DO
            begin
              T                    := Mcells[co-left, ro-Top];
              Mcells[co-Left,ro-Top] := Mcells[co-Left, Bottom-ro];
              Mcells[co-Left, Bottom-ro] := T;
            end;
      PaintFoRectCells;
    end;
  SetDirty(True);
end;

procedure TMainForm.aChangeColorsExecute(Sender: TObject);
VAR co, ro : Integer;
begin
  IF DragStatus = 0 THEN
    begin // change the image
      FOR ro := 0 TO dimn-1 DO
        FOR co := 0 TO dimn-1 DO
          IF cells[co,ro] = TPal.fore THEN
            cells[co,ro] := TPal.back;
      pbDraw.Refresh;
    end
  ELSE
    begin // change the selection
      PrepareSelection;
      WITH FoRect DO
        FOR co := Left TO Right DO
          FOR ro := Top TO bottom DO
            IF MCells[co-Left, ro-Top] = TPal.fore THEN
              MCells[co-Left, ro-Top] := TPal.back;
      PaintFoRectCells;
    end;
  SetDirty(True);
end;

procedure TMainForm.afAddUpdate(Sender: TObject);
begin
  afRemove.Enabled  := lbFrames.ItemIndex > -1;
  afRefresh.Enabled := lbFrames.ItemIndex > -1;
  afRevert.Enabled  := lbFrames.ItemIndex > -1;
  afClone.Enabled   := lbFrames.ItemIndex > -1;
  afUp.Enabled      := lbFrames.ItemIndex > 0;
  afDown.Enabled    := (lbFrames.ItemIndex > -1) AND
                       (lbFrames.ItemIndex < lbFrames.Items.Count-1);
  afPrevu.Enabled := lbFrames.Items.Count > 0;
end;

procedure TMainForm.afAddExecute(Sender: TObject);
begin
  DropDrag;
  ImageIdx := lbFrames.Items.AddObject('', CurrentToCursObj(nil));
  lbFrames.ItemIndex := ImageIdx;
  SetDirty(True);
end;

procedure TMainForm.afRefreshExecute(Sender: TObject);
begin
  DropDrag;
  WITH lbFrames DO
    Items.Objects[ItemIndex] := CurrentToCursObj(TInternalCur(
      Items.Objects[ItemIndex]));
  lbFrames.Refresh;
end;

procedure TMainForm.afRevertExecute(Sender: TObject);
begin
  ClearDrag;
  WITH lbFrames DO
    CursObjToCurrent(TInternalCur(Items.Objects[ItemIndex]));
  pbDraw.Refresh;
end;

procedure TMainForm.afRemoveExecute(Sender: TObject);
VAR Idx : Integer;
begin
  WITH lbFrames DO
    begin
      Idx := ItemIndex;
      TInternalCur(Items.Objects[idx]).Free;
      Items.Delete(Idx);
      IF Idx = Items.Count THEN Dec(Idx);
      ItemIndex := Idx;
      ImageIdx  := ItemIndex;
      IF ItemIndex > -1 THEN
        CursObjToCurrent(TInternalCur(Items.Objects[ItemIndex]));
    end;
  pbDraw.Refresh;
  SetDirty(True);
end;

procedure TMainForm.afCloneExecute(Sender: TObject);
begin
  DropDrag;
  WorkingImage;
  WITH lbFrames DO
    ItemIndex := Items.AddObject('', TInternalCur.Create(
      TInternalCur(Items.Objects [ItemIndex])));
  SetDirty(True);
  ImageIdx := lbFrames.ItemIndex;
end;

procedure TMainForm.afUpExecute(Sender: TObject);
VAR TB : TObject;
begin
  DropDrag;
  WITH lbFrames, Items DO
    begin
      TB                   := Objects[ItemIndex-1];
      Objects[ItemIndex-1] := Objects[ItemIndex];
      Objects[ItemIndex]   := TB;
      ItemIndex            := ItemIndex-1;
      ImageIdx             := ItemIndex;
    end;
  SetDirty(True);
end;

procedure TMainForm.afDownExecute(Sender: TObject);
VAR TB : TObject;
begin
  DropDrag;
  WITH lbFrames, Items DO
    begin
      TB                   := Objects[ItemIndex+1];
      Objects[ItemIndex+1] := Objects[ItemIndex];
      Objects[ItemIndex]   := TB;
      ItemIndex            := ItemIndex+1;
      ImageIdx             := ItemIndex;
    end;
  SetDirty(True);
end;

procedure TMainForm.afJifsExecute(Sender: TObject);
VAR
  N, J, J1 : Integer;
  DefOnly  : Boolean;
begin
  DefOnly := lbFrames.Items.Count = 0;
  IF DefOnly THEN J := allJifs
  ELSE WITH lbFrames DO
    J :=TInternalCur(Items.Objects[ItemIndex]).Tag;
  WITH TJifForm.Create(Self) DO
    try
      SetData(DefOnly, allJifs, J);
      udJifs.Position := J;
      IF ShowModal = idOK THEN
        begin
          J1 := udJifs.Position;
          IF cbCurrent.Checked AND (J1 <> J) THEN
            begin
              WITH lbFrames, Items DO
                TInternalCur(Objects[ItemIndex]).Tag := J1;
              lbFrames.Refresh;
              SetDirty(True);
            end;
          IF cbDefault.Checked AND (J1 <> allJifs) THEN
            begin
              allJifs := J1;
              SetDirty(True);
            end;
          IF cbAll.Checked THEN
            begin
              FOR N := 0 TO lbFrames.Items.Count-1 DO
                WITH TInternalCur(lbFrames.Items.Objects[N]) DO
                  IF Tag <> J1 THEN
                    begin
                      Tag := J1;
                      SetDirty(True);
                    end;
              lbFrames.Refresh;
            end;
        end;
    finally
      Free;
    end;
end;

procedure TMainForm.afPrevuExecute(Sender: TObject);
VAR
  TAC       : TAniCursor;
  N         : Integer;
  tempName  : String;
begin
  IF lbFrames.Items.Count = 0 THEN Exit;
  tempName := TempFileName('ani');
  DropDrag;      
  WorkingImage;
  TAC := TAniCursor.Create(aniTitle, aniAuthor, allJifs, isPal16);
  try
    FOR N := 0 TO lbFrames.Items.Count-1 DO
      TAC.AddImage(TInternalCur(lbFrames.Items.Objects[N]));
    TAC.PrepareToSave(HotX, HotY);
    TAC.SaveToFile(tempName);
    Screen.Cursors[12] := LoadCursorFromFile(PChar(tempName));
    DeleteFile(TempName);
  finally
    TAC.Free;
  end;
end;

procedure TMainForm.mnuhTopicsClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

procedure TMainForm.mnuhAboutClick(Sender: TObject);
begin
  WITH TAboutForm.Create(Self) DO
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.pnlDrawMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.Panels[3].Text := '';
  StatusBar1.Panels[4].Text := '';
end;

procedure TMainForm.pbDrawPaint(Sender: TObject);
VAR co, ro : Integer;
begin
  WITH (Sender AS TPaintBox).Canvas DO
    begin
      SelectPalette(Handle, TPal.PalO, FALSE);
      RealizePalette(Handle);
      Pen.Color := clBlack;
      FOR co := 0 TO dimn DO
        begin
          MoveTo(Margin+(co*OneCell), Margin);
          LineTo(Margin+(co*OneCell), Margin+AllCell);
          MoveTo(Margin, Margin+(co*OneCell));
          LineTo(Margin+AllCell, Margin+(co*OneCell));
        end;
      FOR co := 0 TO dimn-1 DO
        FOR ro := 0 TO dimn-1 DO
          PaintOne(co, ro, -1);
      IF DragStatus > 0 THEN DoFocusRect(True);
      IF DragStatus > 1 THEN PaintFoRectCells;
      IF ToolIdx = 9 THEN
        ShowHotSpot(True);
    end;
end;

procedure TMainForm.pbDrawMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
VAR
  co, ro : Integer;
  clipR  : TRect;
  Pt     : TPoint;
begin
  CASE Button OF
    mbLeft  : begin
      DragIdx  := TPal.fore;
      DragNIdx := TPal.back;
    end;
    mbRight : begin
      DragNIdx := TPal.fore;
      DragIdx  := TPal.back;
    end;
  end;
  clipR := Rect(Margin + pnlDraw.left + pbDraw.Left + 2,
    Margin + pnlDraw.Top + pbDraw.Top + 2,
    Margin + pnlDraw.left + pbDraw.Left + AllCell - 2,
    Margin + pnlDraw.Top + pbDraw.Top + AllCell - 2);
  clipR.Topleft := ClientToScreen(clipR.TopLeft);
  clipR.BottomRight := ClientToScreen(clipR.BottomRight);
  ClipCursor(@clipR);
  GetCursorPos(Pt);
  SetCursorPos(Pt.X, Pt.Y);
  // If we're already dragging and the other button is pressed,
  // don't do anything about the mouse-down event
  CASE Button OF
    mbLeft  : IF GotDown = 2  THEN Exit ELSE GotDown := 1;
    mbRight : IF GotDown = 1  THEN Exit ELSE GotDown := 2;
    ELSE      IF GotDown <> 0 THEN Exit ELSE GotDown := 0;
  end;
  // If the (X,Y) location isn't within the cell array, skip it
  IF NOT CellFmPixel(X, Y, DragX, DragY) THEN Exit;
  IF ToolIdx = 1 THEN
    begin
      CASE DragStatus OF
        0 : begin // nothing to drag
        end;
        1 : begin // something to drag, hasn't been dragged
          IF PtInFoRect(DragX, DragY) THEN
            begin
              DoFocusRect(True);
              FOR ro := FoRect.Top TO FoRect.Bottom DO
                FOR co := FoRect.Left TO FoRect.Right DO
                  begin
                    MCells[co-FoRect.Left,ro-FoRect.Top] :=
                      GetACell(co,ro);
                    SetCell(co,ro, TPal.Back);
                  end;
            end
          ELSE DropDrag;
        end;
        2 : begin // something to drag, has been dragged
          IF PtInFoRect(DragX,DragY) THEN
            DoFocusRect(True)
          ELSE DropDrag;
        end;
      end;
    end
  ELSE
    begin
      IF DragStatus > 0 THEN
        begin
          FOR ro := FoRect.Top TO FoRect.Bottom DO
            FOR co := FoRect.Left TO FoRect.Right DO
              SetCell(co,ro, MCells[co-FoRect.Left,ro-FoRect.Top]);
          ClearDrag;
        end;
    end;
end;

procedure TMainForm.pbDrawMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
VAR
  cX, cY : Integer;

  procedure MoveBrush;
  // Draw a pixel at the new location and all in a line from the
  // old location, so as to have continuous freehand drawing
  begin
    IF (WasX < MaxInt) AND (WasY < MaxInt) THEN
      DrawLine(WasX, WasY, cX, cY, dragIdx);
  end;

  procedure TempLine;
  begin
    WITH pbDraw.Canvas DO
      begin
        Pen.Color := clWhite;
        Pen.Style := psDot;
        Pen.Mode  := pmXor;
        IF (WasX < MaxInt) AND (WasY < MaxInt) THEN
          WITH Rect(CenterOf(WasX), CenterOf(WasY),
            CenterOf(DragX), CenterOf(DragY)) DO
            PolyLine([Point(Left, Top), Point(Right, Bottom)]);
        WITH Rect(CenterOf(cX), CenterOf(cY),
          CenterOf(DragX), CenterOf(DragY)) DO
          PolyLine([Point(Left, Top), Point(Right, Bottom)]);
        Pen.Color := clBlack;
        Pen.Style := psSolid;
        Pen.Mode  := pmCopy;
      end;
  end;

  procedure TempEllipse;
  begin
    WITH pbDraw.Canvas DO
      begin
        Pen.Color   := clWhite;
        Pen.Style   := psDot;
        Pen.Mode    := pmXor;
        Brush.Style := bsClear;
        IF (WasX < MaxInt) AND (WasY < MaxInt) THEN
          Ellipse(CenterOf(DragX-abs(DragX-WasX)),
            CenterOf(dragY-abs(DragY-WasY)),
            CenterOf(dragX+abs(DragX-WasX))+Adj,
            CenterOf(dragY+abs(DragY-WasY))+Adj);
        Ellipse(CenterOf(DragX-abs(DragX-cX)),
          CenterOf(dragY-abs(DragY-cY)),
          CenterOf(dragX+abs(DragX-cX))+Adj,
          CenterOf(dragY+abs(DragY-cY))+Adj);
        Pen.Color := clBlack;
        Pen.Style := psSolid;
        Pen.Mode  := pmCopy;
      end;
  end;

  procedure TempRect;
  begin
    WITH pbDraw.Canvas DO
      begin
        Pen.Color := clWhite;
        Pen.Style := psDot;
        Pen.Mode  := pmXor;
        Brush.Style := bsClear;
        IF (WasX < MaxInt) AND (WasY < MaxInt) THEN
          WITH RectAlign(CenterOf(WasX), CenterOf(WasY),
            CenterOf(DragX), CenterOf(DragY)) DO
              Rectangle(Left, Top, Right+Adj, Bottom+Adj);
        WITH RectAlign(CenterOf(cX), CenterOf(cY),
          CenterOf(DragX), CenterOf(DragY)) DO
            Rectangle(Left, Top, Right+Adj, Bottom+Adj);
        Pen.Color := clBlack;
        Pen.Style := psSolid;
        Pen.Mode  := pmCopy;
      end;
  end;

  procedure DoDragSel;
  begin
    IF (WasX < MaxInt) OR (WasY < MaxInt) THEN
      begin
        UnderFoRectCells;
        DoFocusRect(False);
        OffsetRect(forect, cX-WasX, cY-WasY);
        PaintFoRectCells;
        DoFocusRect(True);
      end;
  end;

begin
  // This code executes even when not dragging
  // After the call to CellFmPixel, cX and cY are guaranteed
  // to be in the range 0..31
  IF NOT CellFmPixel(X, Y, cX, cY) THEN
    begin
      StatusBar1.panels[3].Text := '';
      Exit;
    end
  ELSE IF (cX <> WasX) OR (cY <> WasY) THEN
    begin
      StatusBar1.panels[3].Text := Format('%d,%d', [cX, cY]);
      IF GotDown = 0 THEN
        begin
          IF (DragStatus = 0) OR (NOT PtInFoRect(cX,cY)) THEN
            StatusBar1.panels[4].Text := StringForColor(TPal.Pal,
              Cells[cX,cY])
          ELSE
            StatusBar1.panels[4].Text := StringForColor(TPal.Pal,
              MCells[cX-foRect.Left, cY-foRect.Top])
        end
      ELSE
        StatusBar1.panels[4].Text := '';
    end;
  IF ToolIdx = 1 THEN
    begin
      IF PtInFoRect(cX,cY) THEN pbDraw.Cursor := 11
      ELSE                      pbDraw.Cursor := 2;
    end;
  IF DragIdx < 0 THEN Exit;
  IF GotDown = 0 THEN Exit;
  IF ssCtrl IN Shift THEN
    CASE ToolIdx OF
      4          : SnapLine(DragX, DragY, cX, cY);
      5, 6, 7, 8 : SnapRect(DragX, DragY, cX, cY);
  END;
  // This code executes only while dragging
  IF (cX <> WasX) OR (cY <> WasY) THEN
    begin
      CASE ToolIdx OF
        0 : MoveBrush;
        1 : IF DragStatus > 0 THEN DoDragSel ELSE TempRect;
        2 : ; //dropper - not relevant
        3 : ; //paint can - not relevant
        4 : TempLine;
        5 : TempRect;
        6 : TempRect;
        7 : TempEllipse;
        8 : TempEllipse;
      END;
      CASE ToolIdx OF
        1, 4, 5, 6, 7, 8 :
          StatusBar1.panels[3].Text := Format('(%d,%d) -> (%d,%d)',
            [DragX, DragY, cX, cY]);
      END;
    end;
  WasX := cX;
  WasY := cY;
end;

procedure TMainForm.pbDrawMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
VAR
  cX, cY      : Integer;
  OtherButton : Boolean;

  procedure CleanLine;
  begin
    WITH pbDraw.Canvas DO
      begin
        Pen.Color := clWhite;
        Pen.Style := psDot;
        Pen.Mode  := pmXor;
        WITH Rect(CenterOf(WasX), CenterOf(WasY),
          CenterOf(DragX), CenterOf(DragY)) DO
            PolyLine([Point(Left, Top),
              Point(Right, Bottom)]);
        Pen.Color := clBlack;
        Pen.Style := psSolid;
        Pen.Mode  := pmCopy;
      end;
  end;

  procedure CleanEllipse;
  VAR dX, dY : Integer;
  begin
    WITH pbDraw.Canvas DO
      begin
        Pen.Color   := clWhite;
        Pen.Style   := psDot;
        Pen.Mode    := pmXor;
        Brush.Style := bsClear;
        dX := abs(DragX-WasX);
        dY := abs(DragY-WasY);
        Ellipse(CenterOf(DragX-dX), CenterOf(dragY-dY),
          CenterOf(dragX+dX)+Adj, CenterOf(dragY+dY)+Adj);
        Pen.Color := clBlack;
        Pen.Style := psSolid;
        Pen.Mode := pmCopy;
      end;
  end;

  procedure CleanRect;
  begin
    WITH pbDraw.Canvas DO
      begin
        Pen.Color := clWhite;
        Pen.Style := psDot;
        Pen.Mode := pmXor;
        Brush.Style := bsClear;
        WITH RectAlign(CenterOf(WasX), CenterOf(WasY),
          CenterOf(DragX), CenterOf(DragY)) DO
            Rectangle(Left, Top, Right+Adj, Bottom+Adj);
        Pen.Color := clBlack;
        Pen.Style := psSolid;
        Pen.Mode := pmCopy;
      end;
  end;

  procedure DoBrush;
  begin
    CASE Button OF
      mbLeft   : PaintOne(cX, cY, TPal.fore);
      mbRight  : PaintOne(cX, cY, TPal.back);
    end;
    SetDirty(True);
  end;

  procedure DoDropper;
  begin
    CASE Button OF
      mbLeft   : TPal.fore := Cells[cX, cY];
      mbRight  : TPal.back := Cells[cX, cY];
    end;
    StatusBar1.Refresh;
  end;

  procedure DoFill;
  VAR ToFill : Integer;

    procedure FillPixel(vX, vY : Integer);
    begin
      IF NOT (vX IN [0..dMax]) THEN Exit;
      IF NOT (vY IN [0..dMax]) THEN Exit;
      IF Cells[vX,vY] <> toFill THEN Exit;
      PaintOne(vX,vY,dragIdx);
      FillPixel(vX-1, vY);
      FillPixel(vX+1, vY);
      FillPixel(vX, vY-1);
      FillPixel(vX, vY+1);
    end;

  begin
    IF DragIdx < 0 THEN Exit;
    ToFill := Cells[cX,cY];
    IF ToFill = DragIdx THEN Exit;
    FillPixel(cX,cY);
    SetDirty(True);
  end;

  procedure DoHotSpot;
  begin
    ShowHotSpot(False);
    HotX := cX;
    HotY := cY;
    ShowHotSpot(True);
    SetDirty(True);
  end;

  procedure DrawRect(coloridx, fillIdx : Integer);
  VAR X1, X2, Y1, Y2, co, ro : Integer;
  begin
    WITH RectAlign(DragX, DragY, WasX, WasY) DO
      begin
        X1 := Left; X2 := Right;
        Y1 := Top;  Y2 := Bottom;
      end;
    FOR co := X1 TO X2 DO
      begin
        PaintOne(co, Y1, colorIdx);
        PaintOne(co, Y2, colorIdx);
      end;
    FOR ro := (Y1+1) TO (Y2-1) DO
      begin
        PaintOne(X1, ro, colorIdx);
        PaintOne(X2, ro, colorIdx);
        IF fillIdx < 0 THEN Continue;
        FOR co := X1+1 TO X2-1 DO
          PaintOne(co, ro, fillIdx);
      end;
    SetDirty(True);
  end;

  procedure DoDrop;
  begin
    DragStatus := 2;
    DoFocusRect(True);
    SetDirty(True);
  end;

  procedure DoChoose;
  begin
    FoRect := RectAlign(DragX, DragY, WasX, WasY);

    DragStatus := 1;
    DoFocusRect(True);
  end;

begin
  ClipCursor(nil);
  IF GotDown = 0 THEN Exit;
  CASE Button OF
    mbLeft  : OtherButton := GotDown = 2;
    mbRight : OtherButton := GotDown = 1;
    ELSE      OtherButton := True;
  END;
  // Clean up any temporary lines
  IF (WasX < MaxInt) AND (WasY < MaxInt) THEN
    CASE ToolIdx OF
      1 : IF DragStatus = 0 THEN CleanRect;
      4 : CleanLine;
      5 : CleanRect;
      6 : CleanRect;
      7 : CleanEllipse;
      8 : CleanEllipse;
    end;
  try
    // Pressing the "other" button cancels any action except
    // choose/drag
    IF OtherButton AND (ToolIdx <> 1) THEN
      begin
        GotDown := 0;
        Exit;
      end;
    IF NOT CellFmPixel(X, Y, cX, cY) THEN
      begin
        cX := WasX;
        cY := WasY;
      end;
    // Four tools act on the current cell (cX,cY)
    IF (cX IN [0..dMax]) AND (cY IN [0..dMax]) THEN
      CASE ToolIdx OF
        0 : DoBrush;
        2 : DoDropper;
        3 : DoFill;
        9 : DoHotSpot;
      end;
    IF ssCtrl IN Shift THEN
      CASE ToolIdx OF
        4          : SnapLine(DragX, DragY, cX, cY);
        5, 6, 7, 8 : SnapRect(DragX, DragY, cX, cY);
    END;

    // Six tools act on two point, (cX,cY) and (WasX, WasY)
    IF (WasX < MaxInt) AND (WasY < MaxInt) THEN
      begin
        CASE ToolIdx OF
          1 : IF (DragStatus > 0) THEN DoDrop ELSE DoChoose;
          4 : DrawLine(DragX, DragY, cX, cY, dragIdx);
          5 : DrawRect(dragIdx, -1);
          6 : DrawRect(dragIdx, dragNIdx);
          7 : DrawEllipse(DragX, DragY, Abs(cX - DragX),
            Abs(cY - DragY), dragIdx, -1);
          8 : DrawEllipse(DragX, DragY, Abs(cX - DragX),
            Abs(cY - DragY), dragIdx, dragNIdx);
        end;
      end;
  finally
    // Reset a bunch o' variables
    GotDown  := 0;
    DragIdx  := -1;
    DragNIdx := -1;
    DragX    := -1;
    DragY    := -1;
    WasX     := MaxInt;
    WasY     := MaxInt;
    StatusBar1.Refresh;
  end;
end;

procedure TMainForm.lbFramesDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
VAR R : TRect;
begin
  WITH Control AS TListBox, Canvas DO
    begin
      FillRect(Rect);
      Draw(Rect.left+1, Rect.Top+1, TInternalCur(
        Items.Objects[Index]).AsIcon);
      R := Bounds(Rect.Left+34, Rect.Top+2,
        TextWidth('Length: '), 15);
      DrawText(Canvas.Handle, 'Frame:', -1, R, DT_RIGHT);
      R.Bottom := Rect.Bottom;
      R.Top    := R.Bottom - 18;
      DrawText(Canvas.Handle, 'Length:', -1, R, DT_RIGHT);
      R.Left   := R.Right + 4;
      R.Right  := Rect.Right;
      DrawText(Canvas.Handle, PChar(IntToStr(
        TInternalCur(Items.Objects[Index]).Tag)), -1, R,
          DT_SINGLELINE);
      R.Top    := Rect.Top + 2;
      R.Bottom := R.Top + 15;
      DrawText(Canvas.Handle, PChar(IntToStr(Index)), -1, R,
        DT_SINGLELINE);
    end;
end;

procedure TMainForm.pnlFramesMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// This enables flyover hints for disabled controls
VAR
  P : TPoint;
  N : Integer;
begin
  P := Point(X,Y);
  WITH Sender AS TWinControl DO
    begin
      Hint := '';
      FOR N := 0 TO ControlCount-1 DO
        IF Controls[N] IS TWinControl THEN
          IF PtInRect(TWinControl(Controls[N]).BoundsRect, P) THEN
            Hint := TWinControl(Controls[N]).Hint + ' (disabled)';
      IF Hint = '' THEN
        begin
          Application.CancelHint;
          StatusBar1.Panels[3].Text := '';
        end;
    end;
end;

procedure TMainForm.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);

  procedure PaintPanel(I : Integer);
  VAR R : TRect;
  begin
    R.Left   := Rect.Left+1;
    R.Top    := Rect.Top+1;
    R.Right  := Rect.Right-2;
    R.Bottom := Rect.Bottom - 2;
    WITH StatusBar.Canvas DO
      begin
        SelectPalette(Handle, TPal.PalO, FALSE);
        RealizePalette(Handle);
        CASE I OF
          0..palMaxim : begin
            Brush.Color := TPal.Pal[I];
            FillRect(R);
          end;
          palTrans : begin
            pen.Color := clBlue;
            MoveTo(R.Left, R.Top);
            LineTo(R.Right, R.Bottom);
          end;
          palInvrt : begin
            pen.Color := clRed;
            MoveTo(R.Left, R.Top);
            LineTo(R.Right, R.Bottom);
          end;
        end;
      end;
  end;

  procedure ShowModStatus;
  VAR R : TRect;
  begin
    StatusBar.Canvas.Brush.Color := StatusBar.Color;
    StatusBar.Canvas.FillRect(Rect);
    R := Bounds(Rect.Left+3, Rect.Top, imgAsterisk.Width,
      imgAsterisk.Height);
    IF IsDirty THEN
      StatusBar.Canvas.BrushCopy(R, imgAsterisk.Picture.Bitmap,
        Bounds(0, 0, 13, 13), clWhite);
  end;
begin
  CASE Panel.Index OF
    0 : ShowModStatus;
    1 : PaintPanel(TPal.fore);
    2 : PaintPanel(TPal.back);
  end;
end;

procedure TMainForm.StatusBar1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// This enables hints for status bar's panels
begin
  IF X < sbParts[0] THEN
    StatusBar1.Hint := 'Asterisk here means image has been modified'
  ELSE IF X < sbParts[1] THEN
    StatusBar1.Hint := Format('Foreground color (%s)',
      [StringForColor(TPal.Pal, TPal.fore)])
  ELSE IF X < sbParts[2] THEN
    StatusBar1.Hint := Format('Background color (%s)',
      [StringForColor(TPal.Pal, TPal.back)])
  ELSE IF X < sbParts[3] THEN
    StatusBar1.Hint := 'Cursor location within drawing area'
  ELSE StatusBar1.Hint := ' ';
end;

procedure TMainForm.lbFramesClick(Sender: TObject);
//VAR co, ro : Integer;
begin
  IF lbFrames.ItemIndex <> ImageIdx THEN
    begin
(*      IF ToolIdx = 1 THEN
        begin
          IF DragStatus > 1 THEN
            begin
              FOR ro := FoRect.Top TO FoRect.Bottom DO
                FOR co := FoRect.Left TO FoRect.Right DO
                  SetCell(co, ro, MCells[co-FoRect.Left,
                    ro-FoRect.Top]);
            end;
          ClearDrag;
        end;*)
      DropDrag;
      // Set working image from ItemIndex
      WorkingImage;
      CursObjToCurrent(TInternalCur(lbFrames.Items.Objects[
        lbFrames.ItemIndex]));
      pbDraw.Refresh;
    end;
  ImageIdx := lbFrames.ItemIndex;
end;

procedure TMainForm.AppEvents1Hint(Sender: TObject);
begin
  StatusBar1.panels[4].Text := Application.Hint;
  StatusBar1.Panels[3].Text := '';
end;

function TMainForm.CellFmPixel(X, Y: Integer; VAR cX, cY: Integer):
  Boolean;
// Take an X,Y pixel coordinate and put the corresponding
// cell within the drawing area into cX,cY. Return false if
// outside the drawing grid.
begin
  IF (X < Margin) OR (Y < Margin) OR
    (X >= Margin+AllCell) OR (Y >= Margin+AllCell) THEN
    begin
      cX := -1;
      cY := -1;
    end
  ELSE
    begin
      cX := (X-Margin) DIV OneCell;
      cY := (Y-Margin) DIV OneCell;
    end;
  Result := ValidCell(cX, cY);
end;

function TMainForm.CenterOf(I : Integer) : Integer;
begin
  Result := Margin + (I*OneCell) + HalfCell;
end;

function TMainForm.CheckSave: Boolean;
begin
  Result := True;
  IF IsDirty THEN
    CASE MessageBox(Handle, PChar(Format('Save changes to %s?',
      [NameForFile(theFilename)])), 'TestFile', MB_ICONQUESTION OR
      MB_YESNOCANCEL) OF
      idYES    : amSaveExecute(amSave);
      idNO     : ;
      idCANCEL : Result := False;
    END;
end;

procedure TMainForm.ClearDrag;
begin
  DragStatus := 0;
  DoFocusRect(False);
  FoRect     := Rect(0,0,-1,-1);
end;

procedure TMainForm.ColorChange(Sender: TObject);
begin
  //FIX: Under Windows NT4, the status bar refresh didn't take
  //  effect. No good reason, but inserting the Application.
  //  processMessages command made it work?!
  Application.ProcessMessages;
  StatusBar1.Refresh;
end;

function TMainForm.CurrentToCursObj(Old : TInternalCur) :
  TInternalCur;
// Set the current frame to an icon built from the drawing area.
// If a previous icon existed, copy its Tag (which is the duration)
// and free it.
VAR co, ro : Integer;
begin
  Result := TInternalCur.Create(isPal16, HotX, HotY,
    TPal.Pal);
  IF Assigned(Old) THEN
    begin
      Result.Tag := Old.Tag;
      Old.Free;
    end
  ELSE Result.Tag := allJifs;
  FOR ro := 0 TO dmax DO
    FOR co := 0 TO dmax DO
      WITH Result DO
        CASE Cells[co,dmax-ro] OF
          0..palMaxim : begin
            ColBits[co,ro]  := Cells[co,dmax-ro];
            MaskBits[co,ro] := 0;
          end;
          palTrans : begin
            ColBits[co,ro]  := BlackIdx;
            MaskBits[co,ro] := 1;
          end;
          palInvrt : begin
            ColBits[co,ro]  := WhiteIdx;
            MaskBits[co,ro] := 1;
          end;
        END;
end;

procedure TMainForm.DoFocusRect(Show : Boolean);
// If Show is true, draw a focus rectangle; if not, draw a plain
// black rectangle. If the selection extends beyond the edge
// of the drawing area, don't draw that edge in the focus rect
VAR
  ixL, ixT, ixR, ixB : Integer;
  unL, unT, unR, unB : Boolean;
begin
  ixL := FoRect.Left;    unL := ixL < 0;    IF unL THEN ixL := 0;
  ixR := FoRect.Right;   unR := ixR > dmax; IF unR THEN ixR := dmax;
  ixT := FoRect.Top;     unT := ixT < 0;    IF unT THEN ixT := 0;
  ixB := FoRect.Bottom;  unB := ixB > dmax; IF unB THEN ixB := dmax;
  ixL := Margin + ixL*OneCell;
  ixR := Margin + Succ(ixR)*OneCell;
  ixT := Margin + ixT *OneCell;
  ixB := Margin + Succ(ixB)*OneCell;
  WITH pbDraw.Canvas DO
    begin
      Brush.Style := bsClear;
      Pen.Style   := psSolid;
      IF Show THEN
        begin
          Pen.Color := clWhite;
          MoveTo(ixL, ixT);
          IF unL THEN MoveTo(ixL, ixB) ELSE LineTo(ixL, ixB);
          IF unB THEN MoveTo(ixR, ixB) ELSE LineTo(ixR, ixB);
          IF unR THEN MoveTo(ixR, ixT) ELSE LineTo(ixR, ixT);
          IF unT THEN MoveTo(ixL, ixT) ELSE LineTo(ixL, ixT);
          Pen.Color := clBlack;
          Pen.Style := psDot;
          MoveTo(ixL, ixT);
          IF unL THEN MoveTo(ixL, ixB) ELSE LineTo(ixL, ixB);
          IF unB THEN MoveTo(ixR, ixB) ELSE LineTo(ixR, ixB);
          IF unR THEN MoveTo(ixR, ixT) ELSE LineTo(ixR, ixT);
          IF unT THEN MoveTo(ixL, ixT) ELSE LineTo(ixL, ixT);
          Pen.Style := psSolid;
        end
      ELSE
        begin
          Pen.Color := clBlack;
          MoveTo(ixL, ixT);
          IF unL THEN MoveTo(ixL, ixB) ELSE LineTo(ixL, ixB);
          IF unB THEN MoveTo(ixR, ixB) ELSE LineTo(ixR, ixB);
          IF unR THEN MoveTo(ixR, ixT) ELSE LineTo(ixR, ixT);
          IF unT THEN MoveTo(ixL, ixT) ELSE LineTo(ixL, ixT);
        end;
  end;
end;

procedure TMainForm.DrawEllipse(xCtr, yCtr, xAxis, yAxis : integer;
  colorIdx, fillIdx : Integer);
// Draw an ellipse, calculating which points to draw by
// using a variation on Bresenham's algorithm
VAR
  xAxSq, yAxSq : Integer;
  dec1, dec2   : Integer; // decision variables
  X, Y         : Integer;

  procedure Pixel4(vX, vY : Integer);
  begin
    PaintOne(xCtr - vX, yCtr + vY, colorIdx);
    PaintOne(xCtr + vX, yCtr + vY, colorIdx);
    PaintOne(xCtr - vX, yCtr - vY, colorIdx);
    PaintOne(xCtr + vX, yCtr - vY, colorIdx);
  end;

  procedure DoFill(vX, vY : Integer);
  VAR xL, xR, co : Integer;
  begin
    IF FillIdx < 0 THEN Exit;
    IF vY = yAxis THEN Exit;
    xL := xCtr - vX + 1;
    IF xL < 0 THEN xL := 0;
    xR := xCtr + vX - 1;
    IF xR >= dimn THEN xR := dimn-1;
    FOR co := xL TO xR DO
      begin
        PaintOne(co, yCtr+vY, fillIdx);
        PaintOne(co, yCtr-vY, fillIdx);
      end;
  end;

begin
  xAxSq   := xAxis*xAxis; // precalculate x - axis squared
  yAxSq   := yAxis*yAxis; // precalculate y - axis squared
  X       := 0;
  y       := yAxis;
  dec1 := xAxSq * (1 - 2 * yAxis) + 2 * yAxSq;
  dec2 := yAxSq - 2 * xAxSq * (2 * yAxis - 1);
  Pixel4(x,y);
  WHILE y > 0 DO
    begin
      IF dec1 < 0 THEN
        begin
          Inc(dec1, 2 * yAxSq * (2*x + 3));
          Inc(dec2, 4 * yAxSq * (x + 1));
          Inc(X);
        end
      ELSE IF dec2 < 0 THEN
        begin
          Inc(dec1, 2 * yAxSq * (2*x + 3) - 4 * xAxSq * (y - 1));
          Inc(dec2, 4 * yAxSq * (x + 1) - 2 * xAxSq * (2*y - 3));
          Inc(X);
          Dec(Y);
          DoFill(X,Y);
        end
      ELSE
        begin
          Dec(dec1, 4 * xAxSq * (y - 1));
          Dec(dec2, 2 * xAxSq * (2*y - 3));
          Dec(Y);
          DoFill(X,Y);
        end;
      Pixel4(x,y);
    end;
  SetDirty(True);
end;

procedure TMainForm.DrawLine(x1, y1, x2, y2 : integer;
  colorIdx : Integer);
// A modified version of the well-known Bresenham line-drawing
// algorithm. This version speeds the process by drawing from
// both ends of the line to the middle.
VAR
  Rise     : Integer; // change in Y direction
  Rrun     : Integer; // change in X direction
  LineLen  : Integer; // length in longer direction
  decision : Integer; // : these three decide when to increment
  dIncNeg  : Integer; // : the dependent variable
  dIncPos  : Integer; // :
  xIncNeg  : Integer; // X increment when decision is negative
  yIncNeg  : Integer; // Y increment when decision is negative
  xIncPos  : Integer; // X increment when decision is non-negative
  yIncPos  : Integer; // Y increment when decision is non-negative
  X, Y, N  : Integer;
begin
  Rrun := abs(X2-X1);
  Rise := abs(Y2-Y1);
  IF Rrun > Rise THEN // travel along X, adjust Y per decision
    begin
      LineLen  := Rrun + 1;
      decision := (2 * Rise) - Rrun;
      dIncNeg  := 2 * Rise;
      dIncPos  := 2 * (Rise - Rrun);
      xIncNeg  := 1;
      xIncPos  := 1;
      yIncNeg  := 0;
      yIncPos  := 1;
    end
  ELSE            // travel along Y, adjust X per decision
    begin
      LineLen  := Rise + 1;
      decision := (2 * Rrun) - Rise;
      dIncNeg  := 2 * Rrun;
      dIncPos  := 2 * (Rrun - Rise);
      xIncNeg  := 0;
      xIncPos  := 1;
      yIncNeg  := 1;
      yIncPos  := 1;
    end;
  IF X1 > X2 THEN // going left to right
    begin
      xIncNeg  := -xIncNeg;
      xIncPos  := -xIncPos;
    end;
  IF Y1 > Y2 THEN // going bottom to top
    begin
      yIncNeg  := -yIncNeg;
      yIncPos  := -yIncPos;
    end;
  X := 0; Y := 0;
  FOR N := 0 TO (LineLen DIV 2)-1 DO
    begin
      PaintOne(X1+X, Y1+Y, dragIdx);
      PaintOne(X2-X, Y2-Y, dragIdx);
      IF decision < 0 THEN
        begin
          decision := decision + dIncNeg;
          Inc(X, xIncNeg);
          Inc(Y, yIncNeg);
        end
      ELSE
        begin
          decision := decision + dIncPos;
          Inc(X, xIncPos);
          Inc(Y, yIncPos);
        end;
    end;
  IF Odd(LineLen) THEN // the final middle pixel
    PaintOne(X1+X, Y1+Y, dragIdx);
  SetDirty(True);
end;

procedure TMainForm.DropDrag;
VAR co, ro : Integer;
begin
  // If the current tool is the chooser and something has been
  // dragged out of place, "drop" it by putting the colors into
  // the Cells array.
  IF (ToolIdx = 1) AND (DragStatus = 2) THEN
    FOR ro := FoRect.Top TO FoRect.Bottom DO
      FOR co := FoRect.Left TO FoRect.Right DO
        IF ValidCell(co, ro) THEN
          Cells[co,ro] := MCells[co-FoRect.Left,ro-FoRect.Top];
  ClearDrag;
end;

function TMainForm.GetACell(co, ro : Integer) : Integer;
begin
  Result := 0;
  IF NOT ValidCell(co, ro) THEN Exit;
  Result := Cells[co,ro];
end;

procedure TMainForm.CursObjToCurrent(T: TInternalCur);
VAR co, ro : Integer;
begin
  FOR co := 0 TO dmax DO
    FOR ro := 0 TO dmax DO
      IF T.MaskBits[co,dmax-ro] = 0 THEN
        Cells[co,ro] := T.ColBits[co,dmax-ro]
      ELSE IF T.ColBits[co,dmax-ro] = T.WhiteIdx THEN
        Cells[co,ro] := palInvrt
      ELSE Cells[co,ro] := palTrans;
end;

procedure TMainForm.JustPaint(co, ro, colr : Integer);
// Paint a cell on-screen without changing its stored color
begin
  IF NOT ValidCell(co, ro) THEN Exit;
  WITH pbDraw.Canvas DO
    begin
      SelectPalette(Handle, TPal.PalO, FALSE);
      RealizePalette(Handle);
      CASE Colr OF
        0..palMaxim : begin
          Brush.Color := TPal.Pal[Colr];
          FillRect(Bounds(Margin+(co*OneCell)+1,
            Margin+(ro*OneCell)+1, OneCell-1, OneCell-1))
        end;
        palTrans : begin
          Brush.Color := clBtnFace;
          FillRect(Bounds(Margin+(co*OneCell)+1,
            Margin+(ro*OneCell)+1, OneCell-1, OneCell-1));
          Pen.Color := clBlue;
          MoveTo(Margin+(co*OneCell)+2, Margin+(ro*OneCell)+2);
          LineTo(Margin+((co+1)*OneCell)-1, Margin+((ro+1)*OneCell)-1);
        end;
        palInvrt : begin
          Brush.Color := clBtnFace;
          FillRect(Bounds(Margin+(co*OneCell)+1,
            Margin+(ro*OneCell)+1, OneCell-1, OneCell-1));
          Pen.Color := clRed;
          MoveTo(Margin+(co*OneCell)+2,     Margin+((ro+1)*OneCell)-1);
          LineTo(Margin+((co+1)*OneCell)-1, Margin+(ro*OneCell)+2);
        end;
        palHotSp : begin
          brush.Color := clWhite;
          FillRect(Bounds(Margin+(co*OneCell)+1,
            Margin+(ro*OneCell)+1, OneCell-1, OneCell-1));
          Pen.Color := clBlack;
          MoveTo(Margin+(co*OneCell)+2, Margin+(ro*OneCell)+2);
          LineTo(Margin+((co+1)*OneCell)-1, Margin+((ro+1)*OneCell)-1);
          MoveTo(Margin+(co*OneCell)+2,     Margin+((ro+1)*OneCell)-1);
          LineTo(Margin+((co+1)*OneCell)-1, Margin+(ro*OneCell)+2);
        end;
      end;
    end;
end;

function  TMainForm.MoreThan256 : Boolean;
begin
  Result := GetDeviceCaps(Canvas.Handle, BITSPIXEL) *
    GetDeviceCaps(Canvas.Handle, PLANES) > 8;
end;

function TMainForm.NameForFile(const S: String): String;
begin
  IF S = '' THEN Result := '(untitled)'
  ELSE Result := ExtractFileName(S);
end;

procedure TMainForm.OpenTheFile(const S: String);
VAR
  TAC    : TAniCursor;
  N      : Integer;
  co, ro : Integer;
begin
  TAC := TAniCursor.Create(S);
  try
    IF (TAC.Header.cBitCount >= 4) AND (NOT MoreThan256) THEN
      begin
        MessageBox(Self.Handle, 'This is a 256-color cursor. In '+
          'order to create or edit 256-color cursors, you must '+
          'first set your display properties to a color depth '+
          'greater than 256 colors.', 'CursorDance', MB_OK OR
          MB_ICONSTOP);
        Exit;
      end;
    HotX      := TAC.HotX;
    HotY      := TAC.HotY;
    IsPal16 := TAC.IsPal16;
    TPal.SetPalValues(IsPal16);
    TPal.Pal  := TAC.Palette;
    TPal.Refresh;
    aniTitle  := TAC.Title;
    aniAuthor := TAC.Author;
    allJifs   := TAC.Header.cjifRate;
    ClearDrag;
    FOR N := 0 TO lbFrames.Items.Count-1 DO
      TInternalCur(lbFrames.items.Objects[N]).Free;
    lbFrames.Clear;
    FOR N := 0 TO TAC.Header.cSteps-1 DO
      lbFrames.Items.AddObject('', TInternalCur.Create(TAC.Frames[N],
        TAC.Rates[N]));
    FOR co := 0 TO dmax DO
      FOR ro := 0 TO dmax DO
        PaintOne(co, ro, palTrans);
    TPal.Refresh;
    StatusBar1.Refresh;
    IF TAC.Excess THEN
      ShowMessage('This file contains images that are not part '+
        'of the animated cursor. These images will be ignored.');
    SetFilename(S);
    SetDirty(False);
    ImageIdx  := -1;
    lbFrames.ItemIndex := 0;
    lbFramesClick(lbFrames);
    Screen.Cursors[12] := LoadCursorFromFile(PChar(S));
  finally
    TAC.Free;
  end;
end;

procedure TMainForm.OpenTheFrame(const S : String);
VAR TII : TInternalCur;
begin
  TII := TInternalCur.Create;
  try
    try
      TII.LoadFromFile(S);
    except
      ON Exception DO
        begin
          MessageBox(Self.Handle, 'Error loading .CUR file. Note '+
            'that only 16-color and 256-color cursors can be '+
            'loaded as frames.', 'CursorDance', MB_OK);
          Exit;
        end;
    end;
    IF NOT TII.Valid THEN
      begin
        MessageBox(Self.Handle, 'Error loading .CUR file. Not '+
          'a valid 16-color or 256-color static cursor.',
          'CursorDance', MB_OK);
        Exit;
      end;
    IF IsPal16 AND (NOT TII.Is16Color) THEN
      MessageBox(Self.Handle, 'The current animated cursor is '+
        '16-color, and the static cursor you are attempting to '+
        'load is not 16-color.', 'CursorDance',
        MB_OK OR MB_ICONSTOP)
    ELSE IF (NOT IsPal16) AND TII.Is16Color THEN
      MessageBox(Self.Handle, 'The current animated cursor is '+
        '256-color, and the static cursor you are attempting to '+
        'load is not 256-color.', 'CursorDance',
        MB_OK OR MB_ICONSTOP)
    ELSE
      begin
        DropDrag;
        WorkingImage;
        TII.HotX := Self.HotX;
        TII.HotY := Self.HotY;
        TII.Tag  := allJifs;
        lbFrames.ItemIndex :=
          lbFrames.Items.AddObject('', TInternalCur.Create(TII));
        CursObjToCurrent(TII);
        ImageIdx := lbFrames.ItemIndex;
        SetDirty(True);
        pbDraw.Refresh;
      end;
  finally
    TII.Free;
  end;
  IF S <> '' THEN
    theFolderC := FinalSlash(ExtractFileDir(S));
end;

procedure TMainForm.PaintFoRectCells;
// Display the cells within the focus rectangle of a selection
VAR co, ro : Integer;
begin
  WITH FoRect DO
    FOR co := Left TO Right DO
      FOR ro := Top TO bottom DO
        JustPaint(co, ro, MCells[co-Left, ro-Top]);
end;

procedure TMainForm.PaintOne(co, ro, colr : Integer);
// If colr is -1, repaint with stored color, else set to
// indicated color and paint
begin
  IF NOT ValidCell(co, ro) THEN Exit;
  IF colr >= 0 THEN Cells[co,ro] := colr
  ELSE colr := Cells[co,ro];
  JustPaint(co, ro, colr);
end;

procedure TMainForm.PrepareSelection;
// Prepare the selection for manipulation by the Action tools
VAR co, ro : Integer;
begin
  IF DragStatus = 1 THEN
    begin
      FOR ro := FoRect.Top TO FoRect.Bottom DO
        FOR co := FoRect.Left TO FoRect.Right DO
          begin
            MCells[co-FoRect.Left,ro-FoRect.Top] :=
              GetACell(co,ro);
            SetCell(co,ro, TPal.Back);
          end;
      DragStatus := 2;
    end;
end;

function TMainForm.PtInFoRect(X, Y: Integer): Boolean;
// True if the cell-point is within the selection rectangle
begin
  WITH FoRect DO Result := (Right >= 0) AND
    PtInRect(Rect(Left, Top, Right+1, Bottom+1), Point(X,Y));
end;

function TMainForm.RectAlign(fL, fT, fR, fB: Integer): TRect;
// Given two corners, return a rectangle in which left is
// less than right and top is less than bottom
begin
  IF fL < fR THEN begin Result.Left := fL; Result.Right := fR; end
  ELSE            begin Result.Left := fR; Result.Right := fL; end;
  IF fT < fB THEN begin Result.Top := fT; Result.Bottom := fB; end
  ELSE            begin Result.Top := fB; Result.Bottom := fT; end;
end;

function  TMainForm.RotateRect(R : TRect) : TRect;
begin
  WITH R DO
    begin
      // Result is R rotated about its middle
      Result.Left   := ((Right+Left)DIV 2)-((Bottom-Top) DIV 2);
      Result.Top    := ((Bottom+Top)DIV 2)-((Right-Left) DIV 2);
      Result.Right  := Result.Left + Bottom - Top;
      Result.Bottom := Result.Top + Right - Left;
    end;
  WITH Result DO
    begin
      IF Left > 31 THEN  OffsetRect(Result, 31-Left, 0);
      IF Right < 0 THEN  OffsetRect(Result, 0-Right, 0);
      IF Top > 31 THEN   OffsetRect(Result, 0, 31-Top);
      IF Bottom < 0 THEN OffsetRect(Result, 0, 0-Bottom);
    end;
end;

procedure TMainForm.SaveTheFile(const S: String);
VAR
  TAC : TAniCursor;
  N   : Integer;
begin
  DropDrag;
  WorkingImage;
  TAC := TAniCursor.Create(aniTitle, aniAuthor, allJifs, isPal16);
  try
    FOR N := 0 TO lbFrames.Items.Count-1 DO
      TAC.AddImage(TInternalCur(lbFrames.Items.Objects[N]));
    TAC.PrepareToSave(HotX, HotY);
    TAC.SaveToFile(S);
    SetDirty(False);
    SetFilename(S);
  finally
    TAC.Free;
  end;
end;

procedure TMainForm.SaveTheFrame(const S: String);
begin
  WorkingImage;
  WITH TInternalCur(lbFrames.Items.Objects[lbFrames.ItemIndex]) DO
    begin
      HotX := Self.HotX;
      HotY := Self.HotY;
      SaveToFile(S);
    end;
  theFolderC := FinalSlash(ExtractFileDir(S));
end;

function TMainForm.SetCell(co, ro, colr : Integer) : Boolean;
begin
  Result := ValidCell(co, ro);
  IF Result THEN Cells[co,ro] := colr;
end;

procedure TMainForm.SetDirty(Value: Boolean);
begin
  IF Value = IsDirty THEN Exit;
  IsDirty := Value;
  StatusBar1.refresh;
end;

procedure TMainForm.SetFilename(const S: String);
begin
  theFilename := S;
  Caption := Format('CursorDance - %s', [NameForFile(S)]);
  IF S <> '' THEN
    theFolder := FinalSlash(ExtractFileDir(S));
end;

procedure TMainForm.SetToolIndex(newIndex : Integer);
VAR co, ro : Integer;
begin
  IF ToolIdx = NewIndex THEN Exit;
  IF ToolIdx = 1 THEN
    begin
      DoFocusRect(False);
      IF DragStatus > 1 THEN
        begin
          FOR ro := FoRect.Top TO FoRect.Bottom DO
            FOR co := FoRect.Left TO FoRect.Right DO
              IF ValidCell(co, ro) THEN
                Cells[co,ro] := MCells[co-FoRect.Left,ro-FoRect.Top];
        end;
      ClearDrag;
    end;
  ToolIdx := NewIndex;
  TAction(alTools.Actions[ToolIdx]).Checked := True;
  topTools.Items[ToolIdx].Checked           := True;
  tbTools.Buttons[ToolIdx].Down             := True;
  pbDraw.Cursor := Succ(ToolIdx);
end;

procedure TMainForm.ShowHotSpot(Sho : Boolean);
VAR
  co, ro, co1, ro1, co2, ro2 : Integer;
begin
  co1 := HotX-1; ro1 := HotY-1;
  co2 := HotX+1; ro2 := hotY+1;
  IF co1 < 0 THEN co1 := 0;
  IF ro1 < 0 THEN ro1 := 0;
  IF co2 > dmax THEN co2 := dmax;
  IF ro2 > dmax THEN ro2 := dmax;
  IF Sho THEN
    FOR ro := ro1 TO ro2 DO
      FOR co := co1 TO co2 DO
        begin
          IF NOT ((co=HotX) AND (ro=hotY)) THEN
            JustPaint(co, ro, palHotSp);
        end
  ELSE
    FOR ro := ro1 TO ro2 DO
      FOR co := co1 TO co2 DO
        PaintOne(co, ro, -1);
end;

procedure TMainForm.SnapLine(X1, Y1: Integer; var X2, Y2: Integer);
VAR factor : Double;
begin
  IF (X2=X1) OR (Y2=Y1) THEN Exit;
  factor := (X2-X1) / (Y2-Y1);
  IF Factor >= 2         THEN Y2 := Y1
  ELSE IF Factor <= -2   THEN Y2 := Y1
  ELSE IF Factor >= 1    THEN X2 := X1 + Y2 - Y1
  ELSE IF Factor <= -1   THEN X2 := X1 + Y1 - Y2
  ELSE IF Factor >= 0.5  THEN Y2 := Y1 + X2 - X1
  ELSE IF Factor <= -0.5 THEN Y2 := Y1 + X1 - X2
  ELSE                        X2 := X1;
end;

procedure TMainForm.SnapRect(X1, Y1: Integer; var X2, Y2: Integer);
begin
  IF Abs(X2-X1) > Abs(Y2-Y1) THEN
    IF (X2>X1) XOR (Y2>Y1) THEN Y2 := Y1 + X1 - X2
    ELSE                        Y2 := Y1 + X2 - X1
  ELSE
    IF (X2>X1) XOR (Y2>Y1) THEN X2 := X1 + Y1 - Y2
    ELSE                        X2 := X1 + Y2 - Y1;
end;

procedure TMainForm.UnderFoRectCells;
// Display what's under the focus rectangle
VAR co, ro : Integer;
begin
  WITH FoRect DO
    FOR co := Left TO Right DO
      FOR ro := Top TO Bottom DO
        PaintOne(co, ro, -1);
end;

function TMainForm.ValidCell(vCo, vRo: Integer): Boolean;
begin
  Result := (vCo >= 0) AND (vRo >= 0) AND (vCo < dimn)
    AND (vRo < dimn);
end;

procedure TMainForm.WorkingImage;
begin
  IF ImageIdx <> -1 THEN
    begin
      // Get working image into ImageIdx
      lbFrames.Items.Objects[ImageIdx] := CurrentToCursObj(
        TInternalCur(lbFrames.Items.Objects[ImageIdx]));
      lbFrames.Refresh;
    end;
end;

procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
VAR buffer : ARRAY[0..MAX_PATH] OF Char;
begin
  try
    IF DragQueryFile(Msg.Drop, 0, buffer, MAX_PATH) > 0 THEN
      begin
        IF (uppercase(ExtractFileExt(StrPas(Buffer))) = '.ANI') AND
          CheckSave THEN
          OpenTheFile(StrPas(buffer));
      end;
  finally
    DragFinish(Msg.Drop);
  end;
end;

procedure TMainForm.StatusBar1DblClick(Sender: TObject);
begin
  StatusBar1.Refresh;
end;

procedure TMainForm.FixNTTimerTimer(Sender: TObject);
begin
  StatusBar1.Refresh;
  (Sender AS TTimer).Enabled := False;
end;

end.

