unit hdrformu;

// Copyright  1999 by Ziff-Davis, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  THeaderForm = class(TForm)
    Label1     : TLabel;
    ebTitle    : TEdit;
    ebAuthor   : TEdit;
    btnHelp    : TButton;
    btnCancel  : TButton;
    btnOK      : TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetData(const vTitle, vAuthor : String);
    function GetData(VAR vTitle, vAuthor: String) : Boolean;
  end;

var
  HeaderForm: THeaderForm;

implementation

uses allfuncs;

{$R *.DFM}

procedure THeaderForm.FormCreate(Sender: TObject);
begin
  GetPosFmExeName(Application.ExeName, Self, False);
end;

procedure THeaderForm.FormDestroy(Sender: TObject);
begin
  SetPosToExeName(Application.ExeName, Self, False);
end;

procedure THeaderForm.SetData(const vTitle, vAuthor: String);
begin
  ebTitle.Text  := vTitle;
  ebAuthor.Text := vAuthor;
end;

function THeaderForm.GetData(var vTitle, vAuthor: String): Boolean;
// Returns TRUE if the values have changed
begin
  Result := (ebTitle.Text <> vTitle) OR (ebAuthor.Text <> vAuthor);
  vTitle := ebTitle.Text;
  vAuthor := ebAuthor.Text;
end;

procedure THeaderForm.btnHelpClick(Sender: TObject);
begin
  Application.HelpContext(1);
end;

end.
